
public class Multithread extends Thread {

	private static volatile int count = 0; // global counter (shared resource among multithreads)

	public Multithread(String name, int cnt, int priority) {
		super(name);
		count = cnt;
		setPriority(priority);
	}

	public static void nextCount() {
		count++;
	}
	
	@Override
	public void run() { // Thread run() method override
		int i = 0; // local counter
		while (i<20) {
			System.out.println("Current Thread~~~~~~~~ " + Thread.currentThread().getName() + " " + Thread.currentThread().getId() + " " + Thread.currentThread().getPriority() + " " + Thread.currentThread().getState());

			System.out.println(getName() + " cycle=" + i + " global count=" + count);
			i++; // local counter
			nextCount(); // global counter
			try {
				sleep(1000);
			} catch (InterruptedException e) {
				return;
			}
		}
	}
	/*
	public static void main(String[] args) {		
		Multithread thread1 = new Multithread("Thread1 : ");
		thread1.start();
		Multithread thread2 = new Multithread("Thread2 : ");
		thread2.start();
		Multithread thread3 = new Multithread("Thread3 : ");
		thread3.start();
	}
	*/
}
