
public class MultithreadRunnable implements Runnable {

	private static volatile int count = 0; // global counter (shared resource among multithreadrunnables)
	private String threadName = null;

	public MultithreadRunnable(String name, int cnt) {
		this.threadName = name;
		count = cnt;
	}

	public static void nextCount() {
		count++;
	}
	
	@Override
	public void run() { // Runnable run() implement
		int i = 0; // local counter
		while (i<20) {
			System.out.println(this.threadName + " cycle=" + i + " global count=" + count);
			i++; // local counter
			nextCount(); // global counter
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				return;
			}
		}
	}
	/*
	public static void main(String[] args) {		
		Thread runnable1 = new Thread(new MultithreadRunnable("Thread1 : "), 100);
		runnable1.start();
		Thread runnable2 = new Thread(new MultithreadRunnable("Thread2 : "), 100);
		runnable2.start();
		Thread runnable3 = new Thread(new MultithreadRunnable("Thread3 : "), 100);
		runnable3.start();
	}
	*/
}
